diff --git a/src/providers/ipa/ipa_async_sudo_hostgroups.c b/src/providers/ipa/ipa_async_sudo_hostgroups.c
new file mode 100644
index 0000000000000000000000000000000000000000..3ad625d73bcb363fa00c9f84efc762ce7afc8287
--- /dev/null
+++ b/src/providers/ipa/ipa_async_sudo_hostgroups.c
@@ -0,0 +1,240 @@
+/*
+    SSSD
+
+    Get list of hostgroups that the IPA client is member of.
+
+    Authors:
+        Michal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 Michal Šrubař
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include "providers/ipa/ipa_common.h"
+#include "providers/ipa/ipa_hosts.h"
+#include "providers/ipa/ipa_access.h"
+#include "providers/ldap/sdap_sudo.h"
+
+struct ipa_sudo_get_hostgroups_state {
+
+    struct be_ctx *be_ctx;
+    struct sdap_id_op *sdap_op;
+    struct sdap_id_conn_cache *conn_cache;
+    struct sdap_options *opts;
+
+    const char *hostname;
+    struct sdap_attr_map *host_map;
+    struct sdap_attr_map *hostgroup_map;
+    struct sdap_search_base **host_search_bases;
+ 
+    int dp_error;
+    int error;
+
+    /* Hosts */
+    size_t host_count;
+    struct sysdb_attrs **hosts;
+    size_t hostgroup_count;
+    struct sysdb_attrs **hostgroups;
+};
+
+static errno_t ipa_sudo_get_hostgroups_connect(struct tevent_req *req);
+static void ipa_sudo_get_hostgroups_connect_done(struct tevent_req *subreq);
+static void ipa_sudo_get_hostgroups_done(struct tevent_req *subreq);
+
+struct tevent_req *ipa_sudo_get_hostgroups_send(TALLOC_CTX *mem, 
+                                                struct sdap_sudo_ctx *sudo_ctx)
+{
+    struct ipa_sudo_get_hostgroups_state *state;
+    struct ipa_access_ctx *access_ctx;
+    struct tevent_req *req;
+    int ret = EOK;
+
+    DEBUG(SSSDBG_TRACE_FUNC, "Refreshing information about hostgroups\n");
+
+    access_ctx = talloc_get_type(sudo_ctx->be_ctx->bet_info[BET_ACCESS].pvt_bet_data,
+                                 struct ipa_access_ctx);
+    if (access_ctx == NULL) {
+        DEBUG(SSSDBG_FATAL_FAILURE, ("talloc_get_type() failed\n"));
+        return NULL;
+    }
+
+    req = tevent_req_create(mem, &state, struct ipa_sudo_get_hostgroups_state);
+    if (req == NULL) {
+        DEBUG(SSSDBG_FATAL_FAILURE, ("tevent_req_create() failed\n"));
+        return NULL;
+    }
+
+    state->be_ctx = sudo_ctx->be_ctx;
+    state->conn_cache = access_ctx->sdap_ctx->conn->conn_cache;
+    state->opts = access_ctx->sdap_ctx->opts;
+    state->hostname = talloc_strdup(state, sudo_ctx->ipa_hostname);
+    state->host_map = access_ctx->host_map;
+    state->hostgroup_map = access_ctx->hostgroup_map;
+    state->host_search_bases = access_ctx->host_search_bases;
+    state->dp_error = DP_ERR_OK;
+    state->error = EOK;
+
+    if (state->hostname == NULL) {
+        DEBUG(SSSDBG_FATAL_FAILURE, ("talloc_strdup() failed\n"));
+        ret = ENOMEM;
+        goto immediately;
+    }
+
+    ret = ipa_sudo_get_hostgroups_connect(req);
+    if (ret == EAGAIN) {
+        /* the backend went offline */
+        return req;
+    }
+
+immediately:
+    if (ret != EOK) {
+        tevent_req_error(req, ret);
+        tevent_req_post(req, state->be_ctx->ev);
+    }
+
+    return req;
+}
+
+static errno_t ipa_sudo_get_hostgroups_connect(struct tevent_req *req)
+{
+    struct ipa_sudo_get_hostgroups_state *state;
+    struct tevent_req *subreq;
+    errno_t ret = EOK;
+
+    state = tevent_req_data(req, struct ipa_sudo_get_hostgroups_state);
+
+    if (be_is_offline(state->be_ctx)) {
+        state->dp_error = DP_ERR_OFFLINE;
+        state->error = EAGAIN;
+        return EOK;
+    }
+
+    if (state->sdap_op == NULL) {
+        state->sdap_op = sdap_id_op_create(state, 
+                state->conn_cache);
+        if (state->sdap_op == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE, "sdap_id_op_create() failed\n");
+            state->dp_error = DP_ERR_FATAL;
+            state->error = EIO;
+            return EIO;
+        }
+    }
+
+    subreq = sdap_id_op_connect_send(state->sdap_op, state, &ret);
+    if (subreq == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "sdap_id_op_connect_send() failed: "
+                                    "%d(%s)\n", ret, strerror(ret));
+        talloc_zfree(state->sdap_op);
+        state->dp_error = DP_ERR_FATAL;
+        state->error = ret;
+        return ret;
+    }
+
+    tevent_req_set_callback(subreq, ipa_sudo_get_hostgroups_connect_done, req);
+
+    return ret;
+}
+
+static void ipa_sudo_get_hostgroups_connect_done(struct tevent_req *subreq)
+{
+    struct ipa_sudo_get_hostgroups_state *state;
+    struct tevent_req *req;
+    int dp_error =DP_ERR_OK;
+    int ret = EOK;
+
+    /* req from ipa_sudo_get_hostgroups_send */
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+    state = tevent_req_data(req, struct ipa_sudo_get_hostgroups_state);
+ 
+    ret = sdap_id_op_connect_recv(subreq, &dp_error);
+    talloc_zfree(subreq);
+                
+    if (dp_error == DP_ERR_OFFLINE) {
+        talloc_zfree(state->sdap_op);
+        state->dp_error = DP_ERR_OFFLINE;
+        state->error = EAGAIN;
+        tevent_req_done(req);
+        return;
+    } else if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "IPA sudo hostgroups connection failed "
+                                   "- %s\n", strerror(ret));
+        state->error = ret;
+        tevent_req_error(req, ret);
+        return;
+    }
+
+    DEBUG(SSSDBG_TRACE_FUNC, "IPA sudo hostgroups connection successful\n");
+
+    subreq = ipa_host_info_send(state, 
+                                state->be_ctx->ev,
+                                sdap_id_op_handle(state->sdap_op),
+                                state->opts,
+                                state->hostname,
+                                state->host_map,
+                                state->hostgroup_map,
+                                state->host_search_bases);
+    if (subreq == NULL) {
+        DEBUG(1, ("Could not get host info\n"));
+        tevent_req_error(req, ret);
+    }
+
+    tevent_req_set_callback(subreq, ipa_sudo_get_hostgroups_done, req);
+}
+
+static void ipa_sudo_get_hostgroups_done(struct tevent_req *subreq)
+{
+    struct ipa_sudo_get_hostgroups_state *state;
+    struct tevent_req *req;
+    errno_t ret = EOK;
+
+    req = tevent_req_callback_data(subreq, struct tevent_req);
+    state = tevent_req_data(req, struct ipa_sudo_get_hostgroups_state);
+ 
+    ret = ipa_host_info_recv(subreq, state,
+                             &state->host_count,
+                             &state->hosts,
+                             &state->hostgroup_count,
+                             &state->hostgroups);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        tevent_req_error(req, ret);
+        return;
+    }
+
+    /* getting hostgroups is done now */
+    tevent_req_done(req);
+}
+
+int ipa_sudo_get_hostgroups_recv(struct tevent_req *req,
+                                 TALLOC_CTX *mem_ctx,
+                                 int *dp_error,
+                                 int *error,
+                                 struct sysdb_attrs ***hostgroups,
+                                 size_t *hostgroup_count)
+{
+    struct ipa_sudo_get_hostgroups_state *state;
+
+    state = tevent_req_data(req, struct ipa_sudo_get_hostgroups_state);
+
+    TEVENT_REQ_RETURN_ON_ERROR(req);
+
+    *dp_error = state->dp_error;
+    *error = state->error;
+
+    *hostgroup_count = state->hostgroup_count;
+    *hostgroups = state->hostgroups;
+
+    return EOK;
+}
diff --git a/src/providers/ipa/ipa_async_sudo_hostgroups.h b/src/providers/ipa/ipa_async_sudo_hostgroups.h
new file mode 100644
index 0000000000000000000000000000000000000000..5badb49c0fa2791cf3ac2b97ae1896a7560abce4
--- /dev/null
+++ b/src/providers/ipa/ipa_async_sudo_hostgroups.h
@@ -0,0 +1,37 @@
+/*
+    SSSD
+
+    Authors:
+        MIchal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 MIchal Šrubař
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef _IPA_ASYNC_SUDO_HOSTGROUPS_
+#define _IPA_ASYNC_SUDO_HOSTGROUPS_
+
+struct tevent_req *
+ipa_sudo_get_hostgroups_send(TALLOC_CTX *mem, 
+                             struct sdap_sudo_ctx *sudo_ctx);
+int ipa_sudo_get_hostgroups_recv(struct tevent_req *req,
+                                 TALLOC_CTX *mem_ctx,
+                                 int *dp_error,
+                                 int *error,
+                                 struct sysdb_attrs ***hostgroup,
+                                 size_t *hostgrups_count);
+
+#endif  // _IPA_ASYNC_SUDO_HOSTGROUPS_
diff --git a/src/providers/ipa/ipa_sudo.c b/src/providers/ipa/ipa_sudo.c
index 4863aa55904c47ff7d19e3fdb364c06bad5f5678..d1558e7d62ad0d5a0d9c9c6701658dc934e5f910 100644
--- a/src/providers/ipa/ipa_sudo.c
+++ b/src/providers/ipa/ipa_sudo.c
@@ -1,12 +1,14 @@
 /*
     SSSD
 
-    IPA Provider Initialization functions
+    IPA SUDO Provider Initialization functions
 
     Authors:
         Lukas Slebodnik <lslebodn@redhat.com>
+        MIchal Šrubař <xsruba03@stud.fit.vutbr.cz>
 
     Copyright (C) 2013 Red Hat
+    Copyright (C) 2014 MIchal Šrubař
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
@@ -24,32 +26,288 @@
 
 #include "providers/ipa/ipa_common.h"
 #include "providers/ldap/sdap_sudo.h"
+#include "providers/ipa/ipa_sudo_refreshes.h"
+#include "providers/dp_ptask.h"
+#include "db/sysdb_sudo.h"
+
+void ipa_sudo_handler(struct be_req *be_req);
+static void ipa_sudo_reply(struct tevent_req *req);
+static void ipa_sudo_shutdown(struct be_req *req);
+
+static int ipa_sudo_setup_periodical_refreshes(struct sdap_sudo_ctx *sudo_ctx);
+
+struct bet_ops ipa_sudo_ops = {
+    .handler = ipa_sudo_handler,
+    .finalize = ipa_sudo_shutdown
+};
 
 int ipa_sudo_init(struct be_ctx *be_ctx,
-                  struct ipa_id_ctx *id_ctx,
+                  struct ipa_id_ctx *ipa_id_ctx,
                   struct bet_ops **ops,
                   void **pvt_data)
 {
-    int ret;
-    struct ipa_options *ipa_options;
-    struct sdap_options *ldap_options;
+    struct sdap_id_ctx *id_ctx = ipa_id_ctx->sdap_id_ctx;
+    struct sdap_sudo_ctx *sudo_ctx = NULL;
+    const char *hostname = NULL;
+    char *dot = NULL;
+    int ret = EOK;
 
-    DEBUG(SSSDBG_TRACE_INTERNAL, "Initializing sudo IPA back end\n");
+    DEBUG(SSSDBG_TRACE_INTERNAL, "Initializing IPA sudo back end\n");
 
-    /*
-     * SDAP_SUDO_SEARCH_BASE has already been initialized in
-     * function ipa_get_id_options
-     */
-    ret = sdap_sudo_init(be_ctx, id_ctx->sdap_id_ctx, ops, pvt_data);
+    sudo_ctx = talloc_zero(be_ctx, struct sdap_sudo_ctx);
+    if (sudo_ctx == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "talloc() failed\n");
+        return ENOMEM;
+    }
+
+    sudo_ctx->id_ctx = id_ctx;
+    sudo_ctx->be_ctx = be_ctx;
+    sudo_ctx->ipa_hostname = NULL;
+    sudo_ctx->ipa_hostgroups = NULL;
+    /* no full refresh done yet so we don't have current usn values available */
+    sudo_ctx->full_refresh_done = false;
+
+    *ops = &ipa_sudo_ops;
+    *pvt_data = sudo_ctx;
+
+    ret = ldap_get_sudo_options(id_ctx, be_ctx->cdb,
+                                be_ctx->conf_path, id_ctx->opts,
+                                &sudo_ctx->use_host_filter,
+                                &sudo_ctx->include_regexp,
+                                &sudo_ctx->include_netgroups);
     if (ret != EOK) {
-        DEBUG(SSSDBG_OP_FAILURE, "Cannot initialize LDAP SUDO [%d]: %s\n",
+        DEBUG(SSSDBG_OP_FAILURE, "Cannot get sudo options [%d]: %s\n",
                                   ret, strerror(ret));
         return ret;
     }
 
-    ipa_options = id_ctx->ipa_options;
-    ldap_options = id_ctx->sdap_id_ctx->opts;
+    /* if IPA hostname isn't set in sssd.conf (ipa_hostname option) then it'll
+     * be get automatically by gethostname() in ipa_get_options() and set into
+     * ipa_options->basic as IPA_HOSTNAME
+     */
+    hostname = dp_opt_get_string(ipa_id_ctx->ipa_options->basic, IPA_HOSTNAME);
+    if (hostname != NULL) {
+
+        dot = strchr(hostname, '.');
+        if (dot != NULL) {
+
+            DEBUG(SSSDBG_TRACE_INTERNAL, "Found IPA hostname: %s\n", hostname);
+
+            sudo_ctx->ipa_hostname = talloc_strdup(sudo_ctx, hostname);
+            if (sudo_ctx->ipa_hostname == NULL) {
+                DEBUG(SSSDBG_CRIT_FAILURE, "talloc_strdup() failed\n");
+                return ENOMEM;
+            }
+        }
+    }
+
+    if (hostname == NULL || dot == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Machine hostname ins't FQDN, sudo "
+                                   "won't work correctly");
+        sudo_ctx->use_host_filter = false;
+    }
+
+    return ipa_sudo_setup_periodical_refreshes(sudo_ctx);
+}
+
+static int ipa_sudo_setup_periodical_refreshes(struct sdap_sudo_ctx *sudo_ctx)
+{
+    struct sdap_id_ctx *id_ctx = sudo_ctx->id_ctx;
+    time_t smart_default;
+    time_t smart_interval;
+    time_t full_interval;
+    time_t last_full;
+    time_t delay;
+    int ret = EOK;
+
+    DEBUG(SSSDBG_TRACE_INTERNAL, "Setting up periodical refreshes of sudo "
+                                 "rules using ptask scheduler\n");
+
+    /* get configured values */
+    smart_interval = dp_opt_get_int(id_ctx->opts->basic,
+                                    SDAP_SUDO_SMART_REFRESH_INTERVAL);
+    full_interval = dp_opt_get_int(id_ctx->opts->basic,
+                                   SDAP_SUDO_FULL_REFRESH_INTERVAL);
+
+    if (smart_interval == 0 && full_interval == 0) {
+        smart_default = id_ctx->opts->basic[SDAP_SUDO_SMART_REFRESH_INTERVAL].def_val.number;
+        DEBUG(SSSDBG_MINOR_FAILURE, "At least one periodical update has to be "
+              "enabled. Setting smart refresh interval to default value (%ld).\n",
+              smart_default);
+
+        ret = dp_opt_set_int(id_ctx->opts->basic,
+                             SDAP_SUDO_SMART_REFRESH_INTERVAL,
+                             smart_default);
+        if (ret != EOK) {
+            return ret;
+        }
+    }
+
+    if (full_interval <= smart_interval) {
+        DEBUG(SSSDBG_MINOR_FAILURE, "Full refresh interval has to be greater"
+              "than smart refresh interval. Periodical full refresh will be "
+              "disabled.\n");
+        ret = dp_opt_set_int(id_ctx->opts->basic,
+                             SDAP_SUDO_FULL_REFRESH_INTERVAL,
+                             0);
+        if (ret != EOK) {
+            return ret;
+        }
+    }
+
+    ret = sysdb_sudo_get_last_full_refresh(id_ctx->be->domain, &last_full);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Unable to get the time of the "
+                                   "last full refresh\n");
+        return ret;
+    }
+
+    if (last_full == 0) {
+        /* If this is the first startup, we need to kick off refresh
+         * immediately, to close a window where clients requesting sudo
+         * information won't get an immediate reply with no entries
+         */
+        delay = 0;
+    } else {
+        /* At least one update has previously run, so clients will get cached
+         * data. We will delay the refresh so we don't slow down the startup
+         * process if this is happening during system boot.
+         */
+        delay = 10;
+    }
+
+    /* Schedule full refresh
+     * If the backend is offline then this kind of refresh is disabled and when
+     * we got online again ptask will fire it immediately.
+     *
+     * FIXME: timeouts and delays
+     */
+    ret = be_ptask_create(sudo_ctx,
+                          sudo_ctx->be_ctx,
+                          full_interval,                /* period */
+                          delay,                        /* first delay */
+                          1,                            /* enabled_delay */
+                          0,                            /* random_offset */
+                          60,                           /* timeout */
+                          BE_PTASK_OFFLINE_DISABLE,
+                          0,                            /* backoff - disabled */
+                          ipa_sudo_full_refresh_send,
+                          ipa_sudo_full_refresh_ptask_recv,
+                          sudo_ctx,
+                          "full refresh of IPA sudo rules",
+                          NULL);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_FATAL_FAILURE, "Unable to initialize periodic full "
+                                    "refresh of IPA sudo rules\n");
+    }
+
+    /* Schedule smart refresh
+     * If backend is offline then this kind of refresh is just skipped.
+     */
+    ret = be_ptask_create(sudo_ctx,
+                          sudo_ctx->be_ctx,
+                          smart_interval,
+                          smart_interval,
+                          1,
+                          0,
+                          60,
+                          BE_PTASK_OFFLINE_SKIP,
+                          0,
+                          ipa_sudo_smart_refresh_send,
+                          ipa_sudo_smart_refresh_recv,
+                          sudo_ctx,
+                          "smart refresh of IPA sudo rules",
+                          NULL);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_FATAL_FAILURE, "Unable to initialize periodic smart "
+                                    "refresh of IPA sudo rules\n");
+    }
 
-    ipa_options->id->sudorule_map = ldap_options->sudorule_map;
     return EOK;
 }
+
+void ipa_sudo_handler(struct be_req *be_req)
+{
+    struct be_ctx *be_ctx = be_req_get_be_ctx(be_req);
+    struct tevent_req *req = NULL;
+    struct be_sudo_req *sudo_req = NULL;
+    struct sdap_sudo_ctx *sudo_ctx = NULL;
+    struct sdap_id_ctx *id_ctx = NULL;
+    int ret = EOK;
+
+    sudo_ctx = talloc_get_type(be_ctx->bet_info[BET_SUDO].pvt_bet_data,
+                               struct sdap_sudo_ctx);
+    id_ctx = sudo_ctx->id_ctx;
+    sudo_req = talloc_get_type(be_req_get_data(be_req), struct be_sudo_req);
+
+    switch (sudo_req->type) {
+    case BE_REQ_SUDO_FULL:
+        DEBUG(SSSDBG_TRACE_FUNC, "Issuing a full refresh of IPA sudo rules\n");
+        req = ipa_sudo_full_refresh_send(sudo_ctx, id_ctx->be->ev, id_ctx->be,
+                                         NULL, sudo_ctx);
+        break;
+    case BE_REQ_SUDO_RULES:
+        DEBUG(SSSDBG_TRACE_FUNC, "Issuing a refresh of specific "
+                                 "IPA sudo rules\n");
+        req = ipa_sudo_rules_refresh_send(be_req, sudo_ctx, id_ctx->be,
+                                          id_ctx->opts,
+                                          id_ctx->conn->conn_cache,
+                                          sudo_req->rules);
+        break;
+    default:
+        DEBUG(SSSDBG_CRIT_FAILURE, "Invalid request type: %d\n",sudo_req->type);
+        ret = EINVAL;
+        goto fail;
+    }
+
+    if (req == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Unable to send request: %d\n",
+                                    sudo_req->type);
+        ret = ENOMEM;
+        goto fail;
+    }
+
+    tevent_req_set_callback(req, ipa_sudo_reply, be_req);
+    return;
+
+fail:
+    sdap_handler_done(be_req, DP_ERR_FATAL, ret, NULL);
+}
+
+static void ipa_sudo_reply(struct tevent_req *req)
+{
+    struct be_req *be_req = NULL;
+    struct be_sudo_req *sudo_req = NULL;
+    int dp_error = DP_ERR_OK;
+    int error = EOK;
+    int ret = EOK;
+
+    be_req = tevent_req_callback_data(req, struct be_req);
+    sudo_req = talloc_get_type(be_req_get_data(be_req), struct be_sudo_req);
+
+    switch (sudo_req->type) {
+    case BE_REQ_SUDO_FULL:
+        ret = ipa_sudo_full_refresh_recv(req, &dp_error, &error);
+        break;
+    case BE_REQ_SUDO_RULES:
+        ret = ipa_sudo_rules_refresh_recv(req, &dp_error, &error);
+        break;
+    default:
+        DEBUG(SSSDBG_CRIT_FAILURE, "Invalid request type: %d\n",
+                                    sudo_req->type);
+        ret = EINVAL;
+    }
+
+    talloc_zfree(req);
+    if (ret != EOK) {
+        sdap_handler_done(be_req, DP_ERR_FATAL, ret, strerror(ret));
+        return;
+    }
+
+    sdap_handler_done(be_req, dp_error, error, strerror(error));
+}
+
+static void ipa_sudo_shutdown(struct be_req *req)
+{
+    sdap_handler_done(req, DP_ERR_OK, EOK, NULL);
+}
diff --git a/src/providers/ipa/ipa_sudo.h b/src/providers/ipa/ipa_sudo.h
new file mode 100644
index 0000000000000000000000000000000000000000..4cc105b75973e5095affcb799b01f05923f27594
--- /dev/null
+++ b/src/providers/ipa/ipa_sudo.h
@@ -0,0 +1,52 @@
+/*
+    SSSD
+
+    Authors:
+        Michal Šrubař <xsruba03@stud.fit.vutbr.cz>
+
+    Copyright (C) 2014 Michal Šrubař
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef _IPA_SUDO_H_
+#define _IPA_SUDO_H_
+
+#define IPA_SUDO_CMDS_BASEDN            "cn=sudocmds,cn=sudo,dc=example,dc=cz"
+#define IPA_SUDO_CONTAINER_CMDS         "cn=sudocmds,cn=sudo"
+#define IPA_SUDO_CONTAINER_CMD_GRPS     "cn=sudocmdgroups,cn=sudo"
+
+#define IPA_SUDO_ATTR_ID                "ipaUniqueID"
+#define IPA_SUDO_ATTR_MEMBEROF          "memberOf"
+#define IPA_SUDO_ATTR_CMD               "sudoCmd"
+#define IPA_SUDO_ATTR_ALLOW_CMD         "memberAllowCmd"
+#define IPA_SUDO_ATTR_DENY_CMD          "memberDenyCmd"
+#define IPA_SUDO_ATTR_CMD_ALL           "cmdCategory"
+
+#define IPA_SUDO_MEMBER_USER            "memberUser"
+#define IPA_SUDO_MEMBER_HOST            "memberHost"
+#define IPA_SUDO_RUN_AS                 "ipaSudoRunAs"
+#define IPA_SUDO_RUN_AS_GROUP           "ipaSudoRunAsGroup"
+ 
+#define IPA_HOST_FILTER         "(memberHost=fqdn=%s,cn=computers,cn=accounts,%s)"
+#define IPA_HOST_GROUP_FILTER   "(memberHost=cn=%s,cn=hostgroups,cn=accounts,%s)"
+
+#define IPA_SUDO_RULE_FILTER    "(objectClass=%s)(ipaEnabledFlag=TRUE)"
+#define IPA_SUDO_SMART_FILTER   "&(&(objectclass=%s)(ipaEnabledFlag=TRUE)(%s>=%s)(!(%s=%s)))(|"
+#define IPA_SUDO_RULES_FILTER   "&(&(objectClass=%s)(ipaEnabledFlag=TRUE)(|%s))(|"
+#define IPA_SUDO_FULL_FILTER    "&(objectClass=%s)(ipaEnabledFlag=TRUE)(|(cn=defaults)"
+#define IPA_SUDO_CMD_FILTER     "(&(objectClass=%s)(|"
+
+#endif	// _IPA_SUDO_H_
